﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using TSLab.Script;
using TSLab.Script.Handlers;
using System.ComponentModel;
using TSLab.DataSource;

namespace cacheDataToTxt
{
    public class cacheDataToTxt:IExternalScript
    {
        public void Execute(IContext ctx, ISecurity sec)
        {
            var path = Environment.GetFolderPath(Environment.SpecialFolder.MyDocuments) + @"\BinToTxt\" ;
            var file = Path.Combine(path, sec.SecurityDescription.ToString().Remove(4) + ".txt");
            if (!Directory.Exists(path))
                Directory.CreateDirectory(path);
           
             var sw = new StreamWriter(file,false);
            sw.WriteLine("<DATE>,<TIME>,<MSEC>,<LAST>,<VOL>,<ID>");

            
            for (int i = 0; i < ctx.BarsCount; i++)
            {
                
                string date;
                if (sec.Bars[i].Date.Date.Month < 10)
                    date = sec.Bars[i].Date.Date.Year + "0" + sec.Bars[i].Date.Date.Month;
                else date = sec.Bars[i].Date.Date.Year.ToString() + sec.Bars[i].Date.Date.Month;
                if(sec.Bars[i].Date.Date.Day < 10) date+= "0" + sec.Bars[i].Date.Date.Day;
                else date += sec.Bars[i].Date.Date.Day;

                string time;
                if (sec.Bars[i].Date.TimeOfDay.Hours < 10) time = "0" + sec.Bars[i].Date.TimeOfDay.Hours;
                else time = sec.Bars[i].Date.TimeOfDay.Hours.ToString();
                if (sec.Bars[i].Date.TimeOfDay.Minutes < 10) time += "0" + sec.Bars[i].Date.TimeOfDay.Minutes;
                else time += sec.Bars[i].Date.TimeOfDay.Minutes;
                if (sec.Bars[i].Date.TimeOfDay.Seconds < 10) time += "0" + sec.Bars[i].Date.TimeOfDay.Seconds;
                else time += sec.Bars[i].Date.TimeOfDay.Seconds;

                sw.WriteLine(date + ","
                             + time  + ","
                             + sec.Bars[i].Date.TimeOfDay.Milliseconds.ToString() +","
                              + sec.Bars[i].Close + ","
                             + sec.Bars[i].Volume+","
                             + sec.Bars[i].FirstTradeId);
            }
            sw.Close();
        }
    }
}
